#!/usr/bin/env ruby
require 'tk'

root = Tk.root

$ctrl_st  = false
$shift_st = false
$alt_st   = false

def p_st(btn, x, y, ctrl, shift, alt)
    puts "btn#{btn}(#{x},#{y}) ctrl=>[#{$ctrl_st},#{ctrl}] shift=>[#{$shift_st},#{shift}] alt=>[#{$alt_st},#{alt}]"
end

root.bind('KeyPress-Control_L', proc{puts 'press ctrl'; $ctrl_st = true})
root.bind('KeyRelease-Control_L', proc{puts 'release ctrl'; $ctrl_st = false})
root.bind('KeyPress-Control_R', proc{puts 'press ctrl'; $ctrl_st = true})
root.bind('KeyRelease-Control_R', proc{puts 'release ctrl'; $ctrl_st = false})

root.bind('KeyPress-Shift_L', proc{puts 'press shift'; $shift_st = true})
root.bind('KeyRelease-Shift_L', proc{puts 'release shift'; $shift_st = false})
root.bind('KeyPress-Shift_R', proc{puts 'press shift'; $shift_st = true})
root.bind('KeyRelease-Shift_R', proc{puts 'release shift'; $shift_st = false})

root.bind('KeyPress-Alt_L', proc{puts 'press alt'; $alt_st = true})
root.bind('KeyRelease-Alt_L', proc{puts 'release alt'; $alt_st = false})
root.bind('KeyPress-Alt_R', proc{puts 'press alt'; $alt_st = true})
root.bind('KeyRelease-Alt_R', proc{puts 'release alt'; $alt_st = false})

root.bind('Button', 
          proc{|b, x, y| p_st(b, x, y, false, false, false) }, '%b', '%x','%y')
root.bind('Control-Button', 
          proc{|b, x, y| p_st(b, x, y, true, false, false) }, '%b', '%x','%y')
root.bind('Shift-Button', 
          proc{|b, x, y| p_st(b, x, y, false, true, false) }, '%b', '%x','%y')
root.bind('Alt-Button', 
          proc{|b, x, y| p_st(b, x, y, false, false, true) }, '%b', '%x','%y')
root.bind('Shift-Alt-Button', 
          proc{|b, x, y| p_st(b, x, y, false, true, true) }, '%b', '%x','%y')
root.bind('Control-Alt-Button', 
          proc{|b, x, y| p_st(b, x, y, true, false, true) }, '%b', '%x','%y')
root.bind('Control-Shift-Button', 
          proc{|b, x, y| p_st(b, x, y, true, true, false) }, '%b', '%x','%y')
root.bind('Control-Shift-Alt-Button', 
          proc{|b, x, y| p_st(b, x, y, true, true, true) }, '%b', '%x','%y')

Tk.mainloop
