#!/usr/bin/env ruby
require 'tk'

class Button_Label < TkLabel
  def initialize(*args)
    super(*args)
    configure(:borderwidth=>2, :relief=>:raised, :padx=>'3m', :pady=>'1m')
    @cmd = nil
    @enter = false
    @press = false
    bind('Enter', proc{@enter = true; state(:active)})
    bind('Leave', proc{
           @enter = @press = false; state(:normal); relief(:raised)
         })
    bind('ButtonPress-1', proc{relief(:sunken); @press = true})
    bind('ButtonRelease-1', proc{
           relief(:raised)
           @cmd.call if @enter && @press && @cmd
           @enter = @press = false
         })
  end

  def command(cmd = Proc.new)
    @cmd = cmd
  end
end

TkButton.new(:text=>'button'){
  command {puts "button is pressed!!"}
}.pack(:fill=>:x)

Button_Label.new(:text=>'label'){
  command {puts "label is pressed!!"}
}.pack(:fill=>:x)

Tk.mainloop
