#!/usr/bin/env ruby
require 'tk'

class Button_Label < TkLabel
  def initialize(*args)
    border = 2
    padx = '3m'
    pady = '1m'

    keys = {}
    keys = _symbolkey2str(args.pop) if args[-1].kind_of?(Hash)

    keys['borderwidth'] = border unless keys.key?('borderwidth')
    keys['padx'] = padx unless keys.key?('padx')
    keys['pady'] = pady unless keys.key?('pady')

    keys['relief'] = :raised

    @cmd = keys.delete('command')

    args << keys

    super(*args)

    @enter = false
    @press = false
    bind('Enter', proc{@enter = true; state(:active)})
    bind('Leave', proc{
           @enter = @press = false; state(:normal); relief(:raised)
         })
    bind('ButtonPress-1', proc{relief(:sunken); @press = true})
    bind('ButtonRelease-1', proc{
           relief(:raised)
           @cmd.call if @enter && @press && @cmd
           @enter = @press = false
         })
  end

  def command(cmd = Proc.new)
    @cmd = cmd
    self
  end
  def command=(cmd)
    @cmd = cmd
  end
end

TkButton.new(:text=>'button', 
             :command=>proc{puts "button is pressed!!"}).pack(:fill=>:x)

Button_Label.new(:text=>'label', 
                 :command=>proc{puts "label is pressed!!"}).pack(:fill=>:x)

Tk.mainloop
