#!/usr/bin/env ruby
require 'tk'

c = TkCanvas.new.pack

# create items
TkcLine.new(c, 0, 0, 100, 100, 
            :arrow=>:last, :arrowshape=>[10, 14, 5], :fill=>'blue')

TkcLine.new(c, [0, 0, 30, 100])
TkcLine.new(c, [[0, 0], [100, 30]])

TkcLine.new(c, [350, 250], [120, 200], [200, 50], [300, 20])

TkcRectangle.new(c, [50, 20], [180, 80], 
                 :fill=>'black', :stipple=>'gray12', 
                 :outline=>'orange', :width=>3)

TkcText.new(c, 80, 140, :text=>'Hello, World!!', 
            :font=>'Courier -14 bold italic underline', :fill=>'red')

TkcOval.new(c, 180, 180, 280, 250, :fill=>'yellow')

TkcOval.new(c, 220, 40, 300, 150, :fill=>'yellow', :width=>0)


# set bindings
all = TkcTagAll.new(c)
current = TkcTagCurrent.new(c)

# show current item
c.itembind(all, 'Enter', proc{ p current.find })

# move item
mark = [0, 0]
target = nil

# set target
c.itembind(all, 'ButtonPress-1', proc{|x,y|
             target = current.find[0]
             mark = [x, y]
           }, '%x %y')

# motion
c.itembind(all, 'Button1-Motion', proc{|x,y|
             if target
               target.move(x - mark[0], y - mark[1])
               mark = [x, y]
             end
           }, '%x %y')

# reset target
c.itembind(all, 'ButtonRelease-1', proc{target = nil})

Tk.mainloop
