#!/usr/bin/env ruby
require 'tk'

f = TkFrame.new.pack(:side=>:top, :fill=>:x)
TkLabel.new(f, :text=>'command:').pack(:side=>:left)
ent = TkEntry.new(f).pack(:side=>:left, :fill=>:x, :expand=>true)
btn = TkButton.new(f, :text=>'exec').pack(:side=>:right)
ent.bind('Return'){btn.invoke}
ent.focus # <== set focus

f = TkFrame.new.pack(:side=>:top, :fill=>:both, :expand=>true)
txt = TkText.new(f, :wrap=>:char, :takefocus=>false) {
  pack(:side=>:left, :fill=>:both, :expand=>true)
  yscrollbar(TkScrollbar.new(f).pack(:side=>:right, :fill=>:y))
}
txt.bindtags -= [TkText]
default_cursor = txt.cursor
on_tag_cursor = 'top_left_arrow'

ttag = TkTextTag.new(txt, :foreground=>'blue'){|tag|
  bind('1', proc{|x,y| ent.value = txt.get(*tag.prevrange(_at(x,y)))}, '%x %y')
  bind('Double-1', proc{btn.invoke})
  bind('Enter', proc{txt.cursor(on_tag_cursor)})
  bind('Leave', proc{txt.cursor(default_cursor)})
}

btn.command{
  cmd = ent.value
  cmd.strip!
  ent.value = ''
  return if cmd.empty?
  txt.insert(:end, '> ')
  txt.insert(:end, cmd, ttag)
  txt.see(:end)
  txt.insert(:end, "\n")
  txt.insert(:end, `#{cmd}`)
  txt.see(:end)
}

Tk.mainloop
