#!/usr/bin/env ruby
$KCODE = 'euc'

require 'tk'

class RadioExBox < TkWindow
  def initialize(parent, etc, *vals)
    @frame = TkFrame.new(parent)
    @path = @frame.path

    @var = TkVariable.new('')

    vals.each{|val|
      b = TkRadiobutton.new(@frame, :text=>val, :value=>val, :anchor=>:w, 
                            :variable=>@var).pack(:fill=>:x)
      b.bind('1'){ @frame.focus }
    }

    f_etc = TkFrame.new(@frame).pack

    @ent = TkEntry.new(f_etc, :width=>12) {
      pack(:side=>:right, :fill=>:x)
      focus
    }
    @ent.bind('1'){ @var.value = '' }

    b = TkRadiobutton.new(f_etc, :text=>etc, :value=>'', 
                          :variable=>@var).pack(:side=>:left)
    b.bind('1'){ @ent.focus }
  end

  def value
    if @var.value.empty?
      @ent.value
    else
      @var.value
    end
  end
end


box = RadioExBox.new(nil, '¾', 
                     *%w(ǥȥС ߥ˥奢å  Ƹ)){
  configure(:borderwidth=>3, :relief=>:ridge)
  pack(:padx=>3, :pady=>3, :ipadx=>3, :ipady=>3)
}

f_btn = TkFrame.new.pack

TkButton.new(f_btn, :text=>'show value', 
             :command=>proc{puts box.value}).pack(:side=>:left)

TkButton.new(f_btn, :text=>'exit', :command=>proc{exit}).pack(:side=>:right)

Tk.mainloop
