#!/usr/bin/env ruby
$KCODE = 'euc'

require 'tk'

class RadioExBox < TkWindow
  include TkComposite

  def initialize_composite(keys)
    @var = TkVariable.new('')

    keys = _symbolkey2str(keys)

    unless (vals = keys.delete('values')).kind_of?(Array)
      raise ArgumentError, 'values are not given properly'
    end

    etc_label = keys.delete('etc_label') || 'other'

    @buttons = vals.collect{|val|
      b = TkRadiobutton.new(@frame, :text=>val, :value=>val, :anchor=>:w, 
                            :variable=>@var).pack(:fill=>:x)
      b.bind('1'){ @val_obj = @var; @frame.focus }
    }

    f_etc = TkFrame.new(@frame).pack(:fill=>:x)

    @ent = TkEntry.new(f_etc) {
      pack(:side=>:right, :fill=>:x, :expand=>true)
      focus
    }
    @ent.bind('1'){ @val_obj = @ent; @var.value = '' }

    @val_obj = @ent

    @buttons << @etc = TkRadiobutton.new(f_etc, :text=>etc_label, :value=>'', 
                                         :variable=>@var).pack(:side=>:left)
    @etc.bind('1'){ @val_obj = @ent; @ent.focus }

    delegate('DEFAULT', *@buttons)
    delegate('font', @ent, *@buttons)
    delegate('width', @ent)
    delegate('borderwidth', @frame)
    delegate('relief', @frame)

    configure(keys) unless keys.empty?
  end
  private :initialize_composite

  def value
    @val_obj.value
  end
end

vals = %w(ǥȥС ߥ˥奢å  Ƹ)

box = RadioExBox.new(:etc_label=>'¾', :values=>vals, 
                     :width=>12, :font=>'Helvetica 14 italic') {
  borderwidth 3
  relief :ridge
  pack(:padx=>3, :pady=>3, :ipadx=>3, :ipady=>3)
}

f_btn = TkFrame.new.pack

TkButton.new(f_btn, :text=>'show value', 
             :command=>proc{puts box.value}).pack(:side=>:left)

TkButton.new(f_btn, :text=>'exit', :command=>proc{exit}).pack(:side=>:right)

Tk.mainloop
