#!/usr/bin/env ruby
require 'tk'

class ScrolledListbox < TkListbox
  include TkComposite

  def initialize_composite(keys={})
    @h_scr = TkScrollbar.new(@frame)
    @v_scr = TkScrollbar.new(@frame)

    @lbox = TkListbox.new(@frame)
    @path = @lbox.path

    @lbox.xscrollbar(@h_scr)
    @lbox.yscrollbar(@v_scr)

    TkGrid.rowconfigure(@frame, 0, :weight=>1, :minsize=>0)
    TkGrid.rowconfigure(@frame, 1, :weight=>0)

    TkGrid.columnconfigure(@frame, 0, :weight=>1, :minsize=>0)
    TkGrid.columnconfigure(@frame, 1, :weight=>0)

    @lbox.grid(:row=>0, :column=>0, :sticky=>'news')
    @h_scr.grid(:row=>1, :column=>0, :sticky=>'ew')
    @v_scr.grid(:row=>0, :column=>1, :sticky=>'ns')

    delegate('DEFAULT', @lbox)
    delegate('background', @text, @h_scr, @v_scr)
    delegate('activebackground', @h_scr, @v_scr)
    delegate('troughcolor', @h_scr, @v_scr)
    delegate('repeatdelay', @h_scr, @v_scr)
    delegate('repeatinterval', @h_scr, @v_scr)
    delegate('borderwidth', @frame)
    delegate('relief', @frame)

    configure(keys) unless keys.empty?
  end
end

parent = TkRoot.new

lbox = ScrolledListbox.new(parent).pack

('A'..'Z').each_with_index{|c, i| lbox.insert(:end, c * (i + 1))}

Tk.mainloop
