#!/usr/bin/env ruby
require 'tk'

class ScrollText < TkText
  include TkComposite

  def initialize_composite(keys={})
    @mode = true
    @scr = TkScrollbar.new(@frame).pack(:side=>:right, :fill=>:y)

    @text = TkText.new(@frame, :wrap=>'char')
    @text.yscrollbar(@scr)
    @text.pack(:side=>:left, :fill=>:both, :expand=>true)

    @path = @text.path

    delegate('DEFAULT', @text)
    delegate('relief', @frame)
    delegate('borderwidth', @frame)
    delegate('background', @frame, @text, @scr)
    delegate('activebackground', @scr)
    delegate('troughcolor', @scr)
    delegate('repeatdelay', @scr)
    delegate('repeatinterval', @scr)

    delegate_alias('textborderwidth', 'borderwidth', @text)
    delegate_alias('textrelief', 'relief', @text)

    option_methods([:scrollbar, :scrollbar?])

    configure(keys) unless keys.empty?
  end
  private :initialize_composite

  def scrollbar(mode)
    @mode = mode
    if @mode
      @scr.pack(:side=>:right, :fill=>:y, :before=>@text)
    else
      @scr.unpack
    end
  end
  def scrollbar?
    @mode
  end
end

TkFrame.new{|f|
  ScrollText.new(f).pack(:fill=>:x, :expand=>true)
  ScrollText.new(f, :scrollbar=>false).pack(:fill=>:x, :expand=>true)
}.pack

Tk.mainloop
